/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2014 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_main.c
* Version      : Code Generator for RL78/G10 V1.04.00.03 [07 Aug 2014]
* Device(s)    : R5F10Y16
* Tool-Chain   : CA78K0R
* Description  : This file implements main function.
* Creation Date: 2014/11/28
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_tau.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
#define TIME_1SEC    (200)              /* INTTM01 count for 1sec   */

extern uint16_t G_LED_DATA;             /* LED lighting pattern
    1 : ON
    0 : OFF
*/

extern uint8_t G_count;                 /* INTTM01 counter          */

uint8_t g_inittime;
uint8_t w_count;
uint8_t direction;

void Wait_1sec( void );
/* End user code. Do not edit comment generated here */

void R_MAIN_UserInit(void);
/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    while (1U)
    {


        for (G_LED_DATA = 0b000000000001 ; G_LED_DATA < 0b1000000000000 ; )
        {
            
            Wait_1sec();
            G_LED_DATA = G_LED_DATA << 1;

        }

        for (G_LED_DATA = 0b100000000000 ; G_LED_DATA > 0 ; )
        {
            
            Wait_1sec();
            G_LED_DATA = G_LED_DATA >> 1;

        }

        if( (g_inittime & 0x04) == 0 )
        {
            for (G_LED_DATA = 0b1100000000000 ; G_LED_DATA > 0 ; )
            {
                Wait_1sec();
                G_LED_DATA = G_LED_DATA >> 1;
            }
            for (G_LED_DATA = 0b000000000001 ; G_LED_DATA < 0b10000000000000 ; )
            {
                Wait_1sec();
                G_LED_DATA = G_LED_DATA << 1;
                if(G_LED_DATA == 0b000000000010)
                {
                    G_LED_DATA++;
                }
            }
        }

        for (G_LED_DATA = 0b000000000001 ; G_LED_DATA < 0b1000000000000 ; )
        {
        
            Wait_1sec();
            G_LED_DATA = G_LED_DATA << 1;
            G_LED_DATA++;

        }

        for (G_LED_DATA = 0b111111111111 ; G_LED_DATA > 0 ; )
        {
            
            Wait_1sec();
            G_LED_DATA = G_LED_DATA >> 1;

        }


        for ( w_count = 10 ; w_count > 0 ; w_count-- )
        {
            G_LED_DATA = 0b010101010101;
            Wait_1sec();
            G_LED_DATA = 0b101010101010;
            Wait_1sec();
        }
        if( direction == 0)
        {
            g_inittime -= 4;
            if( g_inittime < 8 )
            {
                direction =1;
            }
        }
        else
        {
            g_inittime += 4;
            if( g_inittime > 72 )
            {
                direction =0;
            }
        }

    }
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */

    /* port initial setting */

    g_inittime = 76;                    /* set ON period time   */
    direction = 0;

    /* timer start  */

    R_TAU0_Channel1_Start();            /* start TM01           */
    EI();

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/***********************************************************************************************************************
* Function Name: Wait_1sec
* Description  : This function wait for 1 sec.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Wait_1sec(void)
{

    G_count = 0;                        /* clear PWM counter        */
        
    while ( G_count < g_inittime )
    {
        NOP();
    }

}
/* End user code. Do not edit comment generated here */
