/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2014 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_tau_user.c
* Version      : Code Generator for RL78/G10 V1.04.00.03 [07 Aug 2014]
* Device(s)    : R5F10Y16
* Tool-Chain   : CA78K0R
* Description  : This file implements device driver for TAU module.
* Creation Date: 2014/11/28
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt INTTM01 r_tau0_channel1_interrupt
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_tau.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
uint8_t G_TIMING;                       /* dynamic light control
    0 : LED1-LED3
    1 : LED4-LED6
    2 : LED7-LED9
    3 : LED10-LED12
*/
uint8_t G_count;                        /* INTTM01 counter          */
uint16_t G_LED_DATA;                    /* LED lighting pattern
    1 : ON
    0 : OFF
*/

uint8_t PM0_image;              /* PM0 register data image  */
uint8_t P0_image;               /* P0 register data image   */


/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_tau0_channel1_interrupt
* Description  : This function INTTM01 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
__interrupt static void r_tau0_channel1_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */


    G_count++;                      /* count up INTTM01 number  */

    switch ( G_TIMING )             /* check timing             */
    {
        case    0:                  /* LED1-3 lighting timing   */
            P0_image = 0b00011100;
            PM0_image = (uint8_t)((G_LED_DATA << 2)& 0b00011100);
            PM0_image ^= 0b00011100;
            PM0_image |= 0b00000010; /* P1 output disable       */
            break;

        case    1:                  /* LED4-6 lighting timing   */
            P0_image = 0b00011100;
            PM0_image = (uint8_t)((G_LED_DATA >> 1)& 0b00011100);
            PM0_image ^= 0b00011100;
            PM0_image |= 0b00000001; /* P0 output disable       */
            break;

        case    2:                  /* LED7-9 lighting timing   */
            P0_image = 0b00000011;
            PM0_image = (uint8_t)((G_LED_DATA >> 4)& 0b00011100);
            PM0_image ^= 0b00011100;
            PM0_image |= 0b00000010; /* P1 output disable       */
            break;

        default:                    /* LED10-12 lighting timing */
            P0_image = 0b00000011;
            PM0_image = (uint8_t)((G_LED_DATA >> 7)& 0b00011100);
            PM0_image ^= 0b00011100;
            PM0_image |= 0b00000001; /* P0 output disable       */
            break;
    }

    PM0 = 0b11111111;               /* output disable           */
    P0 = P0_image;                  /* P0 register data set     */
    PM0 = PM0_image | 0b11100000;   /* PM0 register data set    */

    G_TIMING++;                     /* count up timing          */
    G_TIMING &= 0x03;               /* mask unused bit          */

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
